﻿using System;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;

namespace CompanyModule.Converters
{
    public class BooleanToVisibilityConverter : IValueConverter
    {
        #region IValueConverter Members

        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            if (value != null && value is bool)
            {
                bool useFalseAsVisible = false;
                if (parameter != null && parameter.ToString().ToUpper() == "FALSE")
                    useFalseAsVisible = true;
                if (!useFalseAsVisible)
                {
                    if ((bool)value == true)
                        return Visibility.Visible;
                    else
                        return Visibility.Collapsed;
                }
                else
                {
                    if ((bool)value == true)
                        return Visibility.Collapsed;
                    else
                        return Visibility.Visible;
                }
            }
            else
            {
                bool useNullAsCollapsed = false;
                if (parameter != null && parameter.ToString().ToUpper() == "UseNullAsCollapsed".ToUpper())
                {
                    useNullAsCollapsed = true;
                }

                if (useNullAsCollapsed)
                {
                    return Visibility.Collapsed;
                }
                else
                {
                    return Visibility.Visible;
                }

            }
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            return null;
        }

        #endregion
    }
}
